/// <reference path="../node_modules/pxt-core/built/pxteditor.d.ts" />
/// <reference path="../node_modules/pxt-core/localtypings/blockly.d.ts" />
/// <reference path="../node_modules/pxt-core/built/pxtsim.d.ts" />
declare namespace pxt.editor {
}
declare namespace pxt.editor {
    class FieldLights extends Blockly.Field implements Blockly.FieldCustom {
        isFieldCustom_: boolean;
        private params;
        private boardElement;
        private paletteElement_;
        private neopixels_;
        private paletteButtons;
        static NUM_PIXELS: number;
        static imageWidth: number;
        static imageHeight: number;
        constructor(text: string, params: any, validator?: Function);
        /**
         * Show the inline free-text editor on top of the text.
         * @private
         */
        showEditor_(): void;
        initRing(): void;
        private isInFlyout();
        render_(): void;
        onColorClicked(e: Event, btn: SVGElement): void;
        onPixelClicked(e: Event, neopixel: SVGElement, id: number): void;
        getValue(): string;
        getValueArray(): string;
    }
}
